<script>
import {useStore} from "vuex";
import ProductService from "@/service/ProductService";
import {HOST_API} from "@/vars";
import EventBus from '@/utils/event-bus.js';

export default {
  name: 'ProjectsQualified',
  setup() {
    const store = useStore()
    const productService = new ProductService();
    return {
      store,
      productService,
    }
  },
  data: () => ({
    project: null,
    categoriesList: null,
    id: null,
    submitted: false,
    show_form: false,
    field: null,
    label: null,
    type_field: null,
    map_fields: {
      "title": {
        "user_friendly": "Título",
        "type": "input"
      },
      "description": {
        "user_friendly": "Descripción",
        "type": "textarea"
      },
      "comment": {
        "user_friendly": "Comentarios",
        "type": "textarea"
      },
    },
    status_edit: ["for_correction", "draft", "created"],
    status_end: ["qualified"],
    status_friendly: {
      "qualified": "Calificados",
      "review": "Por calificar",
      "not-qualifier": "Sin calificador",
      "draft": "En Borrador",
    },
    evaluators: null,
    selectedEvaluators: [],
    role: null
  }),
  async created() {
    this.role = this.store.state.profile.role

    this.id = this.$route.params.id;

    if (this.id) {
      await this.getProjectDetail(this.id)
    }

    await this.getEvaluators()

    this.$watch(
        () => this.$route.params,
        async (toParams, previousParams) => {
          await this.getProjectDetail(toParams.id)

          await this.getEvaluators()
        }
    );
  },
  mounted() {
    this.categoriesList = this.store.state.categories;
  },
  computed: {
    showActionStatus() {
      if (this.project) {
        return this.status_edit.includes(this.project.status)
      }
    },
    isAdmin() {
      if (this.role) {
        return this.store.state.admin.includes(this.role)
      }
    },
    isEvaluator() {
      if (this.role) {
        return this.store.state.evaluator.includes(this.role)
      }
    },
    isStatusEnd() {
      if (this.project) {
        return this.status_end.includes(this.project.status)
      }
    },
    isEvaluatorEdit() {
      if(this.role && this.project) {
        return this.project.status === 'send'
      }
    }
  },
  methods: {
    async getProjectDetail(id) {
      if (!id) return
      this.id = id;
      const response = await fetch(HOST_API + `/projects/view/?id=${id}`, {
        method: 'GET',
        headers: {
          'Content-Type': 'application/json',
          'Authorization': `Bearer ${this.store.state.authentication.access}`,
        }
      })
      this.project = await response.json()
      this.selectedEvaluators = this.project.score
    },

    async getEvaluators() {
      const response = await fetch(HOST_API + `/projects/evaluators`, {
        method: 'GET',
        headers: {
          'Content-Type': 'application/json',
          'Authorization': `Bearer ${this.store.state.authentication.access}`,
        }
      })
      this.evaluators = await response.json()
    },

    updateProject() {
      if(this.isAdmin) {
        console.log(this.selectedEvaluators)
        this.project["evaluators"] = this.selectedEvaluators
      }

      fetch(HOST_API + `/projects/update/`, {
        method: 'PUT',
        body: JSON.stringify(this.project),
        headers: {
          'Content-Type': 'application/json',
          'Authorization': `Bearer ${this.store.state.authentication.access}`,
        }
      }).then(res => res.json()).then(response => {
        console.log(response)
        EventBus.emit('updated-project', true)
        this.toast.add({
          severity: 'success',
          summary: response.message,
          detail: `Project ID: ${response.id}`,
          life: 3000
        });
      })
    },

    sendProjectDraft() {
      this.project.status = "send";
      this.updateProject()
    },

    sendProjectSend() {
      this.project.status = "qualified";
      if(this.project.score.score > 0) {
        this.updateProject()
      } else {
        console.error("Es necesaria una calificación")
      }

    },

    saveField() {
      this.submitted = true;
      this.show_form = false;
    },

    hideDialog() {
      this.show_form = false;
      this.submitted = false;
    },

    showFormField(field) {
      this.field = field;
      this.label = this.map_fields[field]["user_friendly"]
      this.type_field = this.map_fields[field]["type"]
      this.show_form = true;
    }
  }
}
</script>

<template>
  <div class="grid">
    <div class="col-12 xl:col-12">
      <div class="card">
        <div class="surface-section">
          <div class="font-medium text-3xl text-900 mb-3">Información del proyecto</div>
          <div class="text-500 mb-5">A continuación puede editar las partes del proyecto antes de enviarlo</div>
          <ul class="list-none p-0 m-0" v-if="project">
            <li class="flex align-items-center py-3 px-2 border-top-1 surface-border flex-wrap">
              <div class="text-500 w-6 md:w-2 font-medium">Título</div>
              <div class="text-900 w-full md:w-8 md:flex-order-0 flex-order-1">
                {{ project.title }}
              </div>
              <div class="w-6 md:w-2 flex justify-content-end" v-if="showActionStatus">
                <Button @click="showFormField('title')" label="Edit" icon="pi pi-pencil" class="p-button-text"></Button>
              </div>
            </li>
            <li class="flex align-items-center py-3 px-2 border-top-1 surface-border flex-wrap">
              <div class="text-500 w-6 md:w-2 font-medium">Categoría</div>
              <div class="text-900 w-full md:w-8 md:flex-order-0 flex-order-1">
                <MultiSelect v-model="project.categories" :options="categoriesList" optionLabel="name"
                             placeholder="Categorías"
                             :filter="true">
                  <template #value="slotProps">
                    <div class="inline-flex align-items-center py-1 px-2 bg-primary text-primary border-round mr-2"
                         v-for="option of slotProps.value" :key="option.id">
                      <span :class="'mr-2 flag flag-co'" style="width: 18px; height: 12px"/>
                      <div>{{ option.name }}</div>
                    </div>
                    <template v-if="!slotProps.value || slotProps.value.length === 0">
                      <div class="p-1">Seleccione una categoría para este proyecto</div>
                    </template>
                  </template>
                  <template #option="slotProps">
                    <div class="flex align-items-center">
                      <span :class="'mr-2 flag flag-co'" style="width: 18px; height: 12px"/>
                      <div>{{ slotProps.option.name }}</div>
                    </div>
                  </template>
                </MultiSelect>
              </div>
            </li>
            <li class="flex align-items-center py-3 px-2 border-top-1 surface-border flex-wrap">
              <div class="text-500 w-6 md:w-2 font-medium">Descripción</div>
              <div class="text-900 w-full md:w-8 md:flex-order-0 flex-order-1">
                {{ project.description }}
              </div>
              <div class="w-6 md:w-2 flex justify-content-end" v-if="showActionStatus">
                <Button @click="showFormField('description')" label="Edit" icon="pi pi-pencil"
                        class="p-button-text"></Button>
              </div>
            </li>
            <li class="flex align-items-center py-3 px-2 border-top-1 surface-border flex-wrap">
              <div class="text-500 w-6 md:w-2 font-medium">Estado</div>
              <div class="text-900 w-full md:w-8 md:flex-order-0 flex-order-1">
                {{ project.status }}
              </div>
            </li>
            <li class="flex align-items-center py-3 px-2 border-top-1 surface-border flex-wrap" v-if="isAdmin && !isStatusEnd">
              <div class="text-500 w-6 md:w-2 font-medium">Calificadores</div>

              <template v-if="isAdmin">
                <MultiSelect v-model="selectedEvaluators" :options="evaluators" optionLabel="name"
                             placeholder="Evaluadores"
                             :filter="true">
                  <template #value="slotProps">
                    <div class="inline-flex align-items-center py-1 px-2 bg-primary text-primary border-round mr-2"
                         v-for="option of slotProps.value" :key="option.id">
                      <span :class="'mr-2 flag flag-co'" style="width: 18px; height: 12px"/>
                      <div>{{ option.name }}</div>
                    </div>
                    <template v-if="!slotProps.value || slotProps.value.length === 0">
                      <div class="p-1">Seleccione evaluadores para este proyecto</div>
                    </template>
                  </template>
                  <template #option="slotProps">
                    <div class="flex align-items-center">
                      <span :class="'mr-2 flag flag-co'" style="width: 18px; height: 12px"/>
                      <div>{{ slotProps.option.name }}</div>
                    </div>
                  </template>
                </MultiSelect>
              </template>
              <template v-else>
                <div class="text-900 w-full md:w-8 md:flex-order-0 flex-order-1">
                  {{ project.evaluators }}
                </div>
              </template>
            </li>
            <template v-if="isEvaluator">
              <li class="flex align-items-center py-3 px-2 border-top-1 border-bottom-1 surface-border flex-wrap">
                <div class="text-500 w-6 md:w-2 font-medium">Calificación</div>
                <div class="text-900 w-full md:w-8 md:flex-order-0 flex-order-1 line-height-3">
                  <div class="col-12 md:col-6">
                    <h5>Calificación</h5>
                    <template v-if="isEvaluatorEdit">
                      <Rating v-model="project.score.score"/>
                    </template>
                    <template v-else>
                      <Rating v-model="project.score.score" readonly/>
                    </template>
                  </div>
                </div>
              </li>
              <li class="flex align-items-center py-3 px-2 border-top-1 border-bottom-1 surface-border flex-wrap">
                <div class="text-500 w-6 md:w-2 font-medium">Comentarios</div>
                <div class="text-900 w-full md:w-8 md:flex-order-0 flex-order-1 line-height-3">
                  {{ project.score.comment }}
                </div>
                <div class="w-6 md:w-2 flex justify-content-end" v-if="isEvaluator && isEvaluatorEdit">
                  <Button @click="showFormField('comment')" label="Edit" icon="pi pi-pencil"
                          class="p-button-text"></Button>
                </div>
              </li>
            </template>
            <template v-else>
              <div class="card">
                <h5>Calificadores</h5>
                <DataTable
                    v-if="project"
                    :value="project.score"
                    dataKey="id"
                    :rows="20"
                    :paginator="true"
                    responsiveLayout="scroll">
                  <Column field="name" header="Nombre" :sortable="true" style="width: 15%"></Column>
                  <Column style="width: 15%">
                    <template #header> Calificación</template>
                    <template #body="slotProps">
                      <Rating v-model="slotProps.data.score" readonly/>
                    </template>
                  </Column>
                  <Column field="comment" header="Comentarios" :sortable="true" style="width: 70%"></Column>
                </DataTable>
              </div>
            </template>

            <li class="pt-5" v-if="(showActionStatus || isAdmin) && !isStatusEnd">
              <Button @click="updateProject" label="Guardar" class="p-button-outlined p-button-info mr-2 mb-2"/>
              <Button @click="sendProjectDraft" label="Enviar a calificación" v-if="showActionStatus"
                      class="p-button-outlined p-button-success mr-2 mb-2"/>
            </li>
            <li class="pt-5" v-if="isEvaluator && isEvaluatorEdit">
              <Button @click="updateProject" label="Guardar comentarios" class="p-button-outlined p-button-info mr-2 mb-2"/>
              <Button @click="sendProjectSend" label="Enviar calificación" class="p-button-outlined p-button-success mr-2 mb-2"/>
            </li>
          </ul>
        </div>
      </div>

      <Dialog v-model:visible="show_form" :style="{ width: '450px' }" header="Edición campos" :modal="true"
              class="p-fluid">

        <div class="field" v-if="type_field === 'input'">
          <label :for="field">{{ label }}</label>
          <InputText :id="field" v-model.trim="project[field]" required="true" autofocus
                     :class="{ 'p-invalid': submitted && !project[field] }"/>
          <small class="p-invalid" v-if="submitted && !project[field]">{{ label }} es requerido.</small>
        </div>
        <div class="field col-12" v-if="type_field === 'textarea'">
          <label :for="field">{{ label }}</label>
          <template v-if="isEvaluator">
            <Textarea :id="field" rows="4" v-model.trim="project['score'][field]" required="true" autofocus
                      :class="{ 'p-invalid': submitted && !project['score'][field] }"/>
            <small class="p-invalid" v-if="submitted && !project['score'][field]">{{ label }} es requerido.</small>
          </template>
          <template v-else>
            <Textarea :id="field" rows="4" v-model.trim="project[field]" required="true" autofocus
                      :class="{ 'p-invalid': submitted && !project[field] }"/>
            <small class="p-invalid" v-if="submitted && !project[field]">{{ label }} es requerido.</small>
          </template>
        </div>
        <template #footer>
          <Button label="Cancel" icon="pi pi-times" class="p-button-text" @click="hideDialog"/>
          <Button label="Save" icon="pi pi-check" class="p-button-text" @click="saveField"/>
        </template>
      </Dialog>
    </div>
  </div>
</template>
